------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008-2010 Vadim Godunko <vgodunko@gmail.com>                 --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt4.Graphics_Items;
with Qt4.Graphics_Items.Directors;
with Qt4.Graphics_Scenes;
with Qt_Ada.Internals.Graphics_Item_Registry;
with Qt_Ada.Internals.Graphics_Items;
with Qt_Ada.Internals.Object_Registry;
with Qt_Ada.Internals.Objects;

with Qt_Ada.Internals.Objects.Graphics_View_Proxies;
pragma Warnings (Off, Qt_Ada.Internals.Objects.Graphics_View_Proxies);
--  Elaboration of the proxy tagged type package register proxy object
--  constructor. Bindings must be able to create proxy object of the
--  corresponding tagged type for works properly.

package body Qt4.Graphics_Views is

   procedure backgroundBrush_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Returns : not null access Qt4.Brushes.Internals.QBrush);
   pragma Import (C, backgroundBrush_0_wrapper,
                     "__Qt4Ada_QGraphicsView_backgroundBrush_0_wrapper");

   procedure centerOn_2_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Pos : not null access constant Qt4.Point_Fs.Internals.QPointF);
   pragma Import (C, centerOn_2_wrapper,
                     "__Qt4Ada_QGraphicsView_centerOn_2_wrapper");

   procedure centerOn_1_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     X : Qt4.Q_Real;
     Y : Qt4.Q_Real);
   pragma Import (C, centerOn_1_wrapper,
                     "__Qt4Ada_QGraphicsView_centerOn_1_wrapper");

   procedure centerOn_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Item : not null access constant Qt_Ada.Internals.Graphics_Items.QGraphicsItem);
   pragma Import (C, centerOn_0_wrapper,
                     "__Qt4Ada_QGraphicsView_centerOn_0_wrapper");

   function dragMode_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.Graphics_Views.Graphics_View_Drag_Mode;
   pragma Import (C, dragMode_0_wrapper,
                     "__Qt4Ada_QGraphicsView_dragMode_0_wrapper");

   procedure ensureVisible_2_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Rect : not null access constant Qt4.Rect_Fs.Internals.QRectF;
     Xmargin : Qt4.Q_Integer;
     Ymargin : Qt4.Q_Integer);
   pragma Import (C, ensureVisible_2_wrapper,
                     "__Qt4Ada_QGraphicsView_ensureVisible_2_wrapper");

   procedure ensureVisible_1_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     X : Qt4.Q_Real;
     Y : Qt4.Q_Real;
     W : Qt4.Q_Real;
     H : Qt4.Q_Real;
     Xmargin : Qt4.Q_Integer;
     Ymargin : Qt4.Q_Integer);
   pragma Import (C, ensureVisible_1_wrapper,
                     "__Qt4Ada_QGraphicsView_ensureVisible_1_wrapper");

   procedure ensureVisible_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Item : not null access constant Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Xmargin : Qt4.Q_Integer;
     Ymargin : Qt4.Q_Integer);
   pragma Import (C, ensureVisible_0_wrapper,
                     "__Qt4Ada_QGraphicsView_ensureVisible_0_wrapper");

   procedure fitInView_2_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Rect : not null access constant Qt4.Rect_Fs.Internals.QRectF;
     Aspect_Radio_Mode : Qt4.Aspect_Ratio_Mode);
   pragma Import (C, fitInView_2_wrapper,
                     "__Qt4Ada_QGraphicsView_fitInView_2_wrapper");

   procedure fitInView_1_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     X : Qt4.Q_Real;
     Y : Qt4.Q_Real;
     W : Qt4.Q_Real;
     H : Qt4.Q_Real;
     Aspect_Radio_Mode : Qt4.Aspect_Ratio_Mode);
   pragma Import (C, fitInView_1_wrapper,
                     "__Qt4Ada_QGraphicsView_fitInView_1_wrapper");

   procedure fitInView_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Item : not null access constant Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Aspect_Radio_Mode : Qt4.Aspect_Ratio_Mode);
   pragma Import (C, fitInView_0_wrapper,
                     "__Qt4Ada_QGraphicsView_fitInView_0_wrapper");

   procedure foregroundBrush_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Returns : not null access Qt4.Brushes.Internals.QBrush);
   pragma Import (C, foregroundBrush_0_wrapper,
                     "__Qt4Ada_QGraphicsView_foregroundBrush_0_wrapper");

   function isInteractive_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.bool;
   pragma Import (C, isInteractive_0_wrapper,
                     "__Qt4Ada_QGraphicsView_isInteractive_0_wrapper");

   function itemAt_1_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Pos : not null access constant Qt4.Points.Internals.QPoint)
       return not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
   pragma Import (C, itemAt_1_wrapper,
                     "__Qt4Ada_QGraphicsView_itemAt_1_wrapper");

   function itemAt_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     X : Qt4.Q_Integer;
     Y : Qt4.Q_Integer)
       return not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
   pragma Import (C, itemAt_0_wrapper,
                     "__Qt4Ada_QGraphicsView_itemAt_0_wrapper");

   procedure mapFromScene_5_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Point : not null access constant Qt4.Point_Fs.Internals.QPointF;
     Returns : not null access Qt4.Points.Internals.QPoint);
   pragma Import (C, mapFromScene_5_wrapper,
                     "__Qt4Ada_QGraphicsView_mapFromScene_5_wrapper");

   procedure mapFromScene_4_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Rect : not null access constant Qt4.Rect_Fs.Internals.QRectF;
     Returns : not null access Qt4.Polygons.Internals.QPolygon);
   pragma Import (C, mapFromScene_4_wrapper,
                     "__Qt4Ada_QGraphicsView_mapFromScene_4_wrapper");

   procedure mapFromScene_3_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Polygon : not null access constant Qt4.Polygon_Fs.Internals.QPolygonF;
     Returns : not null access Qt4.Polygons.Internals.QPolygon);
   pragma Import (C, mapFromScene_3_wrapper,
                     "__Qt4Ada_QGraphicsView_mapFromScene_3_wrapper");

   procedure mapFromScene_2_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Path : not null access constant Qt4.Painter_Paths.Internals.QPainterPath;
     Returns : not null access Qt4.Painter_Paths.Internals.QPainterPath);
   pragma Import (C, mapFromScene_2_wrapper,
                     "__Qt4Ada_QGraphicsView_mapFromScene_2_wrapper");

   procedure mapFromScene_1_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     X : Qt4.Q_Real;
     Y : Qt4.Q_Real;
     Returns : not null access Qt4.Points.Internals.QPoint);
   pragma Import (C, mapFromScene_1_wrapper,
                     "__Qt4Ada_QGraphicsView_mapFromScene_1_wrapper");

   procedure mapFromScene_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     X : Qt4.Q_Real;
     Y : Qt4.Q_Real;
     W : Qt4.Q_Real;
     H : Qt4.Q_Real;
     Returns : not null access Qt4.Polygons.Internals.QPolygon);
   pragma Import (C, mapFromScene_0_wrapper,
                     "__Qt4Ada_QGraphicsView_mapFromScene_0_wrapper");

   procedure mapToScene_5_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Point : not null access constant Qt4.Points.Internals.QPoint;
     Returns : not null access Qt4.Point_Fs.Internals.QPointF);
   pragma Import (C, mapToScene_5_wrapper,
                     "__Qt4Ada_QGraphicsView_mapToScene_5_wrapper");

   procedure mapToScene_4_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Rect : not null access constant Qt4.Rects.Internals.QRect;
     Returns : not null access Qt4.Polygon_Fs.Internals.QPolygonF);
   pragma Import (C, mapToScene_4_wrapper,
                     "__Qt4Ada_QGraphicsView_mapToScene_4_wrapper");

   procedure mapToScene_3_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Polygon : not null access constant Qt4.Polygons.Internals.QPolygon;
     Returns : not null access Qt4.Polygon_Fs.Internals.QPolygonF);
   pragma Import (C, mapToScene_3_wrapper,
                     "__Qt4Ada_QGraphicsView_mapToScene_3_wrapper");

   procedure mapToScene_2_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Path : not null access constant Qt4.Painter_Paths.Internals.QPainterPath;
     Returns : not null access Qt4.Painter_Paths.Internals.QPainterPath);
   pragma Import (C, mapToScene_2_wrapper,
                     "__Qt4Ada_QGraphicsView_mapToScene_2_wrapper");

   procedure mapToScene_1_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     X : Qt4.Q_Integer;
     Y : Qt4.Q_Integer;
     Returns : not null access Qt4.Point_Fs.Internals.QPointF);
   pragma Import (C, mapToScene_1_wrapper,
                     "__Qt4Ada_QGraphicsView_mapToScene_1_wrapper");

   procedure mapToScene_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     X : Qt4.Q_Integer;
     Y : Qt4.Q_Integer;
     W : Qt4.Q_Integer;
     H : Qt4.Q_Integer;
     Returns : not null access Qt4.Polygon_Fs.Internals.QPolygonF);
   pragma Import (C, mapToScene_0_wrapper,
                     "__Qt4Ada_QGraphicsView_mapToScene_0_wrapper");

   procedure matrix_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Returns : not null access Qt4.Matrices.Internals.QMatrix);
   pragma Import (C, matrix_0_wrapper,
                     "__Qt4Ada_QGraphicsView_matrix_0_wrapper");

   procedure resetCachedContent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, resetCachedContent_0_wrapper,
                     "__Qt4Ada_QGraphicsView_resetCachedContent_0_wrapper");

   procedure resetMatrix_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, resetMatrix_0_wrapper,
                     "__Qt4Ada_QGraphicsView_resetMatrix_0_wrapper");

   function resizeAnchor_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.Graphics_Views.Graphics_View_Viewport_Anchor;
   pragma Import (C, resizeAnchor_0_wrapper,
                     "__Qt4Ada_QGraphicsView_resizeAnchor_0_wrapper");

   procedure rotate_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Angle : Qt4.Q_Real);
   pragma Import (C, rotate_0_wrapper,
                     "__Qt4Ada_QGraphicsView_rotate_0_wrapper");

   procedure scale_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Sx : Qt4.Q_Real;
     Sy : Qt4.Q_Real);
   pragma Import (C, scale_0_wrapper,
                     "__Qt4Ada_QGraphicsView_scale_0_wrapper");

   function scene_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return not null access Qt_Ada.Internals.Objects.QObject;
   pragma Import (C, scene_0_wrapper,
                     "__Qt4Ada_QGraphicsView_scene_0_wrapper");

   procedure sceneRect_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Returns : not null access Qt4.Rect_Fs.Internals.QRectF);
   pragma Import (C, sceneRect_0_wrapper,
                     "__Qt4Ada_QGraphicsView_sceneRect_0_wrapper");

   procedure setBackgroundBrush_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Brush : not null access constant Qt4.Brushes.Internals.QBrush);
   pragma Import (C, setBackgroundBrush_0_wrapper,
                     "__Qt4Ada_QGraphicsView_setBackgroundBrush_0_wrapper");

   procedure setDragMode_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Mode : Qt4.Graphics_Views.Graphics_View_Drag_Mode);
   pragma Import (C, setDragMode_0_wrapper,
                     "__Qt4Ada_QGraphicsView_setDragMode_0_wrapper");

   procedure setForegroundBrush_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Brush : not null access constant Qt4.Brushes.Internals.QBrush);
   pragma Import (C, setForegroundBrush_0_wrapper,
                     "__Qt4Ada_QGraphicsView_setForegroundBrush_0_wrapper");

   procedure setInteractive_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Allowed : Qt4.bool);
   pragma Import (C, setInteractive_0_wrapper,
                     "__Qt4Ada_QGraphicsView_setInteractive_0_wrapper");

   procedure setMatrix_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Matrix : not null access constant Qt4.Matrices.Internals.QMatrix;
     Combine : Qt4.bool);
   pragma Import (C, setMatrix_0_wrapper,
                     "__Qt4Ada_QGraphicsView_setMatrix_0_wrapper");

   procedure setResizeAnchor_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Anchor : Qt4.Graphics_Views.Graphics_View_Viewport_Anchor);
   pragma Import (C, setResizeAnchor_0_wrapper,
                     "__Qt4Ada_QGraphicsView_setResizeAnchor_0_wrapper");

   procedure setScene_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Scene : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, setScene_0_wrapper,
                     "__Qt4Ada_QGraphicsView_setScene_0_wrapper");

   procedure setSceneRect_1_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Rect : not null access constant Qt4.Rect_Fs.Internals.QRectF);
   pragma Import (C, setSceneRect_1_wrapper,
                     "__Qt4Ada_QGraphicsView_setSceneRect_1_wrapper");

   procedure setSceneRect_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     X : Qt4.Q_Real;
     Y : Qt4.Q_Real;
     W : Qt4.Q_Real;
     H : Qt4.Q_Real);
   pragma Import (C, setSceneRect_0_wrapper,
                     "__Qt4Ada_QGraphicsView_setSceneRect_0_wrapper");

   procedure setTransformationAnchor_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Anchor : Qt4.Graphics_Views.Graphics_View_Viewport_Anchor);
   pragma Import (C, setTransformationAnchor_0_wrapper,
                     "__Qt4Ada_QGraphicsView_setTransformationAnchor_0_wrapper");

   procedure setViewportUpdateMode_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Mode : Qt4.Graphics_Views.Graphics_View_Viewport_Update_Mode);
   pragma Import (C, setViewportUpdateMode_0_wrapper,
                     "__Qt4Ada_QGraphicsView_setViewportUpdateMode_0_wrapper");

   procedure shear_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Sh : Qt4.Q_Real;
     Sv : Qt4.Q_Real);
   pragma Import (C, shear_0_wrapper,
                     "__Qt4Ada_QGraphicsView_shear_0_wrapper");

   function transformationAnchor_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.Graphics_Views.Graphics_View_Viewport_Anchor;
   pragma Import (C, transformationAnchor_0_wrapper,
                     "__Qt4Ada_QGraphicsView_transformationAnchor_0_wrapper");

   procedure translate_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Dx : Qt4.Q_Real;
     Dy : Qt4.Q_Real);
   pragma Import (C, translate_0_wrapper,
                     "__Qt4Ada_QGraphicsView_translate_0_wrapper");

   function viewportUpdateMode_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.Graphics_Views.Graphics_View_Viewport_Update_Mode;
   pragma Import (C, viewportUpdateMode_0_wrapper,
                     "__Qt4Ada_QGraphicsView_viewportUpdateMode_0_wrapper");

   procedure updateSceneRect_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Rect : not null access constant Qt4.Rect_Fs.Internals.QRectF);
   pragma Import (C, updateSceneRect_0_wrapper,
                     "__Qt4Ada_QGraphicsView_updateSceneRect_0_wrapper");

   procedure setCacheMode_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Mode : Cache_Mode_Flags);
   pragma Import
    (C, setCacheMode_wrapper, "__Qt4Ada_QGraphicsView_setCacheMode_wrapper");

   procedure setRenderHint_wrapper
    (Self    : not null access Qt_Ada.Internals.Objects.QObject;
     Hint    : Qt4.Painters.Render_Hint;
     Enabled : Qt4.bool);
   pragma Import
    (C, setRenderHint_wrapper, "__Qt4Ada_QGraphicsView_setRenderHint_wrapper");

   --------------------
   -- Set_Cache_Mode --
   --------------------

   procedure Set_Cache_Mode
    (Self : not null access Q_Graphics_View'Class;
     Mode : Cache_Mode_Flags)
   is
   begin
      setCacheMode_wrapper (Self.QObject_View, Mode);
   end Set_Cache_Mode;

   ---------------------
   -- Set_Render_Hint --
   ---------------------

   procedure Set_Render_Hint
    (Self    : not null access Q_Graphics_View'Class;
     Hint    : Qt4.Painters.Render_Hint;
     Enabled : Boolean := True)
   is
   begin
      setRenderHint_wrapper (Self.QObject_View,
                             Hint,
                             Qt4.To_bool (Enabled));
   end Set_Render_Hint;

   pragma Style_Checks ("N");

   ----------------------
   -- Background_Brush --
   ----------------------

   function Background_Brush
    (Self : not null access constant Q_Graphics_View'Class)
       return Qt4.Brushes.Q_Brush
   is
      Returns : Qt4.Brushes.Q_Brush;

   begin
      backgroundBrush_0_wrapper
       (Self.QObject_View,
        Qt4.Brushes.Internals.QBrush_View (Returns));

      return Returns;
   end Background_Brush;

   ---------------
   -- Center_On --
   ---------------

   procedure Center_On
    (Self : not null access Q_Graphics_View'Class;
     Pos : Qt4.Point_Fs.Q_Point_F)
   is
   begin
      centerOn_2_wrapper
       (Self.QObject_View,
        Qt4.Point_Fs.Internals.QPointF_View (Pos));
   end Center_On;

   ---------------
   -- Center_On --
   ---------------

   procedure Center_On
    (Self : not null access Q_Graphics_View'Class;
     X : Qt4.Q_Real;
     Y : Qt4.Q_Real)
   is
   begin
      centerOn_1_wrapper
       (Self.QObject_View,
        X,
        Y);
   end Center_On;

   ---------------
   -- Center_On --
   ---------------

   procedure Center_On
    (Self : not null access Q_Graphics_View'Class;
     Item : not null access constant Qt4.Graphics_Items.Q_Graphics_Item'Class)
   is
   begin
      centerOn_0_wrapper
       (Self.QObject_View,
        Item.QGraphicsItem_View);
   end Center_On;

   ---------------
   -- Drag_Mode --
   ---------------

   function Drag_Mode
    (Self : not null access constant Q_Graphics_View'Class)
       return Qt4.Graphics_Views.Graphics_View_Drag_Mode
   is
   begin
      return
        dragMode_0_wrapper
         (Self.QObject_View);
   end Drag_Mode;

   --------------------
   -- Ensure_Visible --
   --------------------

   procedure Ensure_Visible
    (Self : not null access Q_Graphics_View'Class;
     Rect : Qt4.Rect_Fs.Q_Rect_F;
     Xmargin : Qt4.Q_Integer
       :=  50;
     Ymargin : Qt4.Q_Integer
       :=  50)
   is
   begin
      ensureVisible_2_wrapper
       (Self.QObject_View,
        Qt4.Rect_Fs.Internals.QRectF_View (Rect),
        Xmargin,
        Ymargin);
   end Ensure_Visible;

   --------------------
   -- Ensure_Visible --
   --------------------

   procedure Ensure_Visible
    (Self : not null access Q_Graphics_View'Class;
     X : Qt4.Q_Real;
     Y : Qt4.Q_Real;
     W : Qt4.Q_Real;
     H : Qt4.Q_Real;
     Xmargin : Qt4.Q_Integer
       :=  50;
     Ymargin : Qt4.Q_Integer
       :=  50)
   is
   begin
      ensureVisible_1_wrapper
       (Self.QObject_View,
        X,
        Y,
        W,
        H,
        Xmargin,
        Ymargin);
   end Ensure_Visible;

   --------------------
   -- Ensure_Visible --
   --------------------

   procedure Ensure_Visible
    (Self : not null access Q_Graphics_View'Class;
     Item : not null access constant Qt4.Graphics_Items.Q_Graphics_Item'Class;
     Xmargin : Qt4.Q_Integer
       :=  50;
     Ymargin : Qt4.Q_Integer
       :=  50)
   is
   begin
      ensureVisible_0_wrapper
       (Self.QObject_View,
        Item.QGraphicsItem_View,
        Xmargin,
        Ymargin);
   end Ensure_Visible;

   -----------------
   -- Fit_In_View --
   -----------------

   procedure Fit_In_View
    (Self : not null access Q_Graphics_View'Class;
     Rect : Qt4.Rect_Fs.Q_Rect_F;
     Aspect_Radio_Mode : Qt4.Aspect_Ratio_Mode
       := Qt4.Ignore_Aspect_Ratio)
   is
   begin
      fitInView_2_wrapper
       (Self.QObject_View,
        Qt4.Rect_Fs.Internals.QRectF_View (Rect),
        Aspect_Radio_Mode);
   end Fit_In_View;

   -----------------
   -- Fit_In_View --
   -----------------

   procedure Fit_In_View
    (Self : not null access Q_Graphics_View'Class;
     X : Qt4.Q_Real;
     Y : Qt4.Q_Real;
     W : Qt4.Q_Real;
     H : Qt4.Q_Real;
     Aspect_Radio_Mode : Qt4.Aspect_Ratio_Mode
       := Qt4.Ignore_Aspect_Ratio)
   is
   begin
      fitInView_1_wrapper
       (Self.QObject_View,
        X,
        Y,
        W,
        H,
        Aspect_Radio_Mode);
   end Fit_In_View;

   -----------------
   -- Fit_In_View --
   -----------------

   procedure Fit_In_View
    (Self : not null access Q_Graphics_View'Class;
     Item : not null access constant Qt4.Graphics_Items.Q_Graphics_Item'Class;
     Aspect_Radio_Mode : Qt4.Aspect_Ratio_Mode
       := Qt4.Ignore_Aspect_Ratio)
   is
   begin
      fitInView_0_wrapper
       (Self.QObject_View,
        Item.QGraphicsItem_View,
        Aspect_Radio_Mode);
   end Fit_In_View;

   ----------------------
   -- Foreground_Brush --
   ----------------------

   function Foreground_Brush
    (Self : not null access constant Q_Graphics_View'Class)
       return Qt4.Brushes.Q_Brush
   is
      Returns : Qt4.Brushes.Q_Brush;

   begin
      foregroundBrush_0_wrapper
       (Self.QObject_View,
        Qt4.Brushes.Internals.QBrush_View (Returns));

      return Returns;
   end Foreground_Brush;

   --------------------
   -- Is_Interactive --
   --------------------

   function Is_Interactive
    (Self : not null access constant Q_Graphics_View'Class)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (isInteractive_0_wrapper
           (Self.QObject_View));
   end Is_Interactive;

   -------------
   -- Item_At --
   -------------

   function Item_At
    (Self : not null access constant Q_Graphics_View'Class;
     Pos : Qt4.Points.Q_Point)
       return not null access Qt4.Graphics_Items.Q_Graphics_Item'Class
   is
   begin
      return
        Qt4.Graphics_Items.Q_Graphics_Item'Class
         (Qt_Ada.Internals.Graphics_Item_Registry.To_Q_Graphics_Item
           (itemAt_1_wrapper
             (Self.QObject_View,
              Qt4.Points.Internals.QPoint_View (Pos))).all)'Access;
   end Item_At;

   -------------
   -- Item_At --
   -------------

   function Item_At
    (Self : not null access constant Q_Graphics_View'Class;
     X : Qt4.Q_Integer;
     Y : Qt4.Q_Integer)
       return not null access Qt4.Graphics_Items.Q_Graphics_Item'Class
   is
   begin
      return
        Qt4.Graphics_Items.Q_Graphics_Item'Class
         (Qt_Ada.Internals.Graphics_Item_Registry.To_Q_Graphics_Item
           (itemAt_0_wrapper
             (Self.QObject_View,
              X,
              Y)).all)'Access;
   end Item_At;

   --------------------
   -- Map_From_Scene --
   --------------------

   function Map_From_Scene
    (Self : not null access constant Q_Graphics_View'Class;
     Point : Qt4.Point_Fs.Q_Point_F)
       return Qt4.Points.Q_Point
   is
      Returns : Qt4.Points.Q_Point;

   begin
      mapFromScene_5_wrapper
       (Self.QObject_View,
        Qt4.Point_Fs.Internals.QPointF_View (Point),
        Qt4.Points.Internals.QPoint_View (Returns));

      return Returns;
   end Map_From_Scene;

   --------------------
   -- Map_From_Scene --
   --------------------

   function Map_From_Scene
    (Self : not null access constant Q_Graphics_View'Class;
     Rect : Qt4.Rect_Fs.Q_Rect_F)
       return Qt4.Polygons.Q_Polygon
   is
      Returns : Qt4.Polygons.Q_Polygon;

   begin
      mapFromScene_4_wrapper
       (Self.QObject_View,
        Qt4.Rect_Fs.Internals.QRectF_View (Rect),
        Qt4.Polygons.Internals.QPolygon_View (Returns));

      return Returns;
   end Map_From_Scene;

   --------------------
   -- Map_From_Scene --
   --------------------

   function Map_From_Scene
    (Self : not null access constant Q_Graphics_View'Class;
     Polygon : Qt4.Polygon_Fs.Q_Polygon_F)
       return Qt4.Polygons.Q_Polygon
   is
      Returns : Qt4.Polygons.Q_Polygon;

   begin
      mapFromScene_3_wrapper
       (Self.QObject_View,
        Qt4.Polygon_Fs.Internals.QPolygonF_View (Polygon),
        Qt4.Polygons.Internals.QPolygon_View (Returns));

      return Returns;
   end Map_From_Scene;

   --------------------
   -- Map_From_Scene --
   --------------------

   function Map_From_Scene
    (Self : not null access constant Q_Graphics_View'Class;
     Path : Qt4.Painter_Paths.Q_Painter_Path)
       return Qt4.Painter_Paths.Q_Painter_Path
   is
      Returns : Qt4.Painter_Paths.Q_Painter_Path;

   begin
      mapFromScene_2_wrapper
       (Self.QObject_View,
        Qt4.Painter_Paths.Internals.QPainterPath_View (Path),
        Qt4.Painter_Paths.Internals.QPainterPath_View (Returns));

      return Returns;
   end Map_From_Scene;

   --------------------
   -- Map_From_Scene --
   --------------------

   function Map_From_Scene
    (Self : not null access constant Q_Graphics_View'Class;
     X : Qt4.Q_Real;
     Y : Qt4.Q_Real)
       return Qt4.Points.Q_Point
   is
      Returns : Qt4.Points.Q_Point;

   begin
      mapFromScene_1_wrapper
       (Self.QObject_View,
        X,
        Y,
        Qt4.Points.Internals.QPoint_View (Returns));

      return Returns;
   end Map_From_Scene;

   --------------------
   -- Map_From_Scene --
   --------------------

   function Map_From_Scene
    (Self : not null access constant Q_Graphics_View'Class;
     X : Qt4.Q_Real;
     Y : Qt4.Q_Real;
     W : Qt4.Q_Real;
     H : Qt4.Q_Real)
       return Qt4.Polygons.Q_Polygon
   is
      Returns : Qt4.Polygons.Q_Polygon;

   begin
      mapFromScene_0_wrapper
       (Self.QObject_View,
        X,
        Y,
        W,
        H,
        Qt4.Polygons.Internals.QPolygon_View (Returns));

      return Returns;
   end Map_From_Scene;

   ------------------
   -- Map_To_Scene --
   ------------------

   function Map_To_Scene
    (Self : not null access constant Q_Graphics_View'Class;
     Point : Qt4.Points.Q_Point)
       return Qt4.Point_Fs.Q_Point_F
   is
      Returns : Qt4.Point_Fs.Q_Point_F;

   begin
      mapToScene_5_wrapper
       (Self.QObject_View,
        Qt4.Points.Internals.QPoint_View (Point),
        Qt4.Point_Fs.Internals.QPointF_View (Returns));

      return Returns;
   end Map_To_Scene;

   ------------------
   -- Map_To_Scene --
   ------------------

   function Map_To_Scene
    (Self : not null access constant Q_Graphics_View'Class;
     Rect : Qt4.Rects.Q_Rect)
       return Qt4.Polygon_Fs.Q_Polygon_F
   is
      Returns : Qt4.Polygon_Fs.Q_Polygon_F;

   begin
      mapToScene_4_wrapper
       (Self.QObject_View,
        Qt4.Rects.Internals.QRect_View (Rect),
        Qt4.Polygon_Fs.Internals.QPolygonF_View (Returns));

      return Returns;
   end Map_To_Scene;

   ------------------
   -- Map_To_Scene --
   ------------------

   function Map_To_Scene
    (Self : not null access constant Q_Graphics_View'Class;
     Polygon : Qt4.Polygons.Q_Polygon)
       return Qt4.Polygon_Fs.Q_Polygon_F
   is
      Returns : Qt4.Polygon_Fs.Q_Polygon_F;

   begin
      mapToScene_3_wrapper
       (Self.QObject_View,
        Qt4.Polygons.Internals.QPolygon_View (Polygon),
        Qt4.Polygon_Fs.Internals.QPolygonF_View (Returns));

      return Returns;
   end Map_To_Scene;

   ------------------
   -- Map_To_Scene --
   ------------------

   function Map_To_Scene
    (Self : not null access constant Q_Graphics_View'Class;
     Path : Qt4.Painter_Paths.Q_Painter_Path)
       return Qt4.Painter_Paths.Q_Painter_Path
   is
      Returns : Qt4.Painter_Paths.Q_Painter_Path;

   begin
      mapToScene_2_wrapper
       (Self.QObject_View,
        Qt4.Painter_Paths.Internals.QPainterPath_View (Path),
        Qt4.Painter_Paths.Internals.QPainterPath_View (Returns));

      return Returns;
   end Map_To_Scene;

   ------------------
   -- Map_To_Scene --
   ------------------

   function Map_To_Scene
    (Self : not null access constant Q_Graphics_View'Class;
     X : Qt4.Q_Integer;
     Y : Qt4.Q_Integer)
       return Qt4.Point_Fs.Q_Point_F
   is
      Returns : Qt4.Point_Fs.Q_Point_F;

   begin
      mapToScene_1_wrapper
       (Self.QObject_View,
        X,
        Y,
        Qt4.Point_Fs.Internals.QPointF_View (Returns));

      return Returns;
   end Map_To_Scene;

   ------------------
   -- Map_To_Scene --
   ------------------

   function Map_To_Scene
    (Self : not null access constant Q_Graphics_View'Class;
     X : Qt4.Q_Integer;
     Y : Qt4.Q_Integer;
     W : Qt4.Q_Integer;
     H : Qt4.Q_Integer)
       return Qt4.Polygon_Fs.Q_Polygon_F
   is
      Returns : Qt4.Polygon_Fs.Q_Polygon_F;

   begin
      mapToScene_0_wrapper
       (Self.QObject_View,
        X,
        Y,
        W,
        H,
        Qt4.Polygon_Fs.Internals.QPolygonF_View (Returns));

      return Returns;
   end Map_To_Scene;

   ------------
   -- Matrix --
   ------------

   function Matrix
    (Self : not null access constant Q_Graphics_View'Class)
       return Qt4.Matrices.Q_Matrix
   is
      Returns : Qt4.Matrices.Q_Matrix;

   begin
      matrix_0_wrapper
       (Self.QObject_View,
        Qt4.Matrices.Internals.QMatrix_View (Returns));

      return Returns;
   end Matrix;

   --------------------------
   -- Reset_Cached_Content --
   --------------------------

   procedure Reset_Cached_Content
    (Self : not null access Q_Graphics_View'Class)
   is
   begin
      resetCachedContent_0_wrapper
       (Self.QObject_View);
   end Reset_Cached_Content;

   ------------------
   -- Reset_Matrix --
   ------------------

   procedure Reset_Matrix
    (Self : not null access Q_Graphics_View'Class)
   is
   begin
      resetMatrix_0_wrapper
       (Self.QObject_View);
   end Reset_Matrix;

   -------------------
   -- Resize_Anchor --
   -------------------

   function Resize_Anchor
    (Self : not null access constant Q_Graphics_View'Class)
       return Qt4.Graphics_Views.Graphics_View_Viewport_Anchor
   is
   begin
      return
        resizeAnchor_0_wrapper
         (Self.QObject_View);
   end Resize_Anchor;

   ------------
   -- Rotate --
   ------------

   procedure Rotate
    (Self : not null access Q_Graphics_View'Class;
     Angle : Qt4.Q_Real)
   is
   begin
      rotate_0_wrapper
       (Self.QObject_View,
        Angle);
   end Rotate;

   -----------
   -- Scale --
   -----------

   procedure Scale
    (Self : not null access Q_Graphics_View'Class;
     Sx : Qt4.Q_Real;
     Sy : Qt4.Q_Real)
   is
   begin
      scale_0_wrapper
       (Self.QObject_View,
        Sx,
        Sy);
   end Scale;

   -----------
   -- Scene --
   -----------

   function Scene
    (Self : not null access constant Q_Graphics_View'Class)
       return not null access Qt4.Graphics_Scenes.Q_Graphics_Scene'Class
   is
   begin
      return
        Qt4.Graphics_Scenes.Q_Graphics_Scene'Class
         (Qt_Ada.Internals.Object_Registry.To_Q_Object
           (scene_0_wrapper
             (Self.QObject_View)).all)'Access;
   end Scene;

   ----------------
   -- Scene_Rect --
   ----------------

   function Scene_Rect
    (Self : not null access constant Q_Graphics_View'Class)
       return Qt4.Rect_Fs.Q_Rect_F
   is
      Returns : Qt4.Rect_Fs.Q_Rect_F;

   begin
      sceneRect_0_wrapper
       (Self.QObject_View,
        Qt4.Rect_Fs.Internals.QRectF_View (Returns));

      return Returns;
   end Scene_Rect;

   --------------------------
   -- Set_Background_Brush --
   --------------------------

   procedure Set_Background_Brush
    (Self : not null access Q_Graphics_View'Class;
     Brush : Qt4.Brushes.Q_Brush)
   is
   begin
      setBackgroundBrush_0_wrapper
       (Self.QObject_View,
        Qt4.Brushes.Internals.QBrush_View (Brush));
   end Set_Background_Brush;

   -------------------
   -- Set_Drag_Mode --
   -------------------

   procedure Set_Drag_Mode
    (Self : not null access Q_Graphics_View'Class;
     Mode : Qt4.Graphics_Views.Graphics_View_Drag_Mode)
   is
   begin
      setDragMode_0_wrapper
       (Self.QObject_View,
        Mode);
   end Set_Drag_Mode;

   --------------------------
   -- Set_Foreground_Brush --
   --------------------------

   procedure Set_Foreground_Brush
    (Self : not null access Q_Graphics_View'Class;
     Brush : Qt4.Brushes.Q_Brush)
   is
   begin
      setForegroundBrush_0_wrapper
       (Self.QObject_View,
        Qt4.Brushes.Internals.QBrush_View (Brush));
   end Set_Foreground_Brush;

   ---------------------
   -- Set_Interactive --
   ---------------------

   procedure Set_Interactive
    (Self : not null access Q_Graphics_View'Class;
     Allowed : Standard.Boolean)
   is
   begin
      setInteractive_0_wrapper
       (Self.QObject_View,
        Qt4.To_bool (Allowed));
   end Set_Interactive;

   ----------------
   -- Set_Matrix --
   ----------------

   procedure Set_Matrix
    (Self : not null access Q_Graphics_View'Class;
     Matrix : Qt4.Matrices.Q_Matrix;
     Combine : Standard.Boolean
       := False)
   is
   begin
      setMatrix_0_wrapper
       (Self.QObject_View,
        Qt4.Matrices.Internals.QMatrix_View (Matrix),
        Qt4.To_bool (Combine));
   end Set_Matrix;

   -----------------------
   -- Set_Resize_Anchor --
   -----------------------

   procedure Set_Resize_Anchor
    (Self : not null access Q_Graphics_View'Class;
     Anchor : Qt4.Graphics_Views.Graphics_View_Viewport_Anchor)
   is
   begin
      setResizeAnchor_0_wrapper
       (Self.QObject_View,
        Anchor);
   end Set_Resize_Anchor;

   ---------------
   -- Set_Scene --
   ---------------

   procedure Set_Scene
    (Self : not null access Q_Graphics_View'Class;
     Scene : not null access Qt4.Graphics_Scenes.Q_Graphics_Scene'Class)
   is
   begin
      setScene_0_wrapper
       (Self.QObject_View,
        Scene.QObject_View);
   end Set_Scene;

   --------------------
   -- Set_Scene_Rect --
   --------------------

   procedure Set_Scene_Rect
    (Self : not null access Q_Graphics_View'Class;
     Rect : Qt4.Rect_Fs.Q_Rect_F)
   is
   begin
      setSceneRect_1_wrapper
       (Self.QObject_View,
        Qt4.Rect_Fs.Internals.QRectF_View (Rect));
   end Set_Scene_Rect;

   --------------------
   -- Set_Scene_Rect --
   --------------------

   procedure Set_Scene_Rect
    (Self : not null access Q_Graphics_View'Class;
     X : Qt4.Q_Real;
     Y : Qt4.Q_Real;
     W : Qt4.Q_Real;
     H : Qt4.Q_Real)
   is
   begin
      setSceneRect_0_wrapper
       (Self.QObject_View,
        X,
        Y,
        W,
        H);
   end Set_Scene_Rect;

   -------------------------------
   -- Set_Transformation_Anchor --
   -------------------------------

   procedure Set_Transformation_Anchor
    (Self : not null access Q_Graphics_View'Class;
     Anchor : Qt4.Graphics_Views.Graphics_View_Viewport_Anchor)
   is
   begin
      setTransformationAnchor_0_wrapper
       (Self.QObject_View,
        Anchor);
   end Set_Transformation_Anchor;

   ------------------------------
   -- Set_Viewport_Update_Mode --
   ------------------------------

   procedure Set_Viewport_Update_Mode
    (Self : not null access Q_Graphics_View'Class;
     Mode : Qt4.Graphics_Views.Graphics_View_Viewport_Update_Mode)
   is
   begin
      setViewportUpdateMode_0_wrapper
       (Self.QObject_View,
        Mode);
   end Set_Viewport_Update_Mode;

   -----------
   -- Shear --
   -----------

   procedure Shear
    (Self : not null access Q_Graphics_View'Class;
     Sh : Qt4.Q_Real;
     Sv : Qt4.Q_Real)
   is
   begin
      shear_0_wrapper
       (Self.QObject_View,
        Sh,
        Sv);
   end Shear;

   ---------------------------
   -- Transformation_Anchor --
   ---------------------------

   function Transformation_Anchor
    (Self : not null access constant Q_Graphics_View'Class)
       return Qt4.Graphics_Views.Graphics_View_Viewport_Anchor
   is
   begin
      return
        transformationAnchor_0_wrapper
         (Self.QObject_View);
   end Transformation_Anchor;

   ---------------
   -- Translate --
   ---------------

   procedure Translate
    (Self : not null access Q_Graphics_View'Class;
     Dx : Qt4.Q_Real;
     Dy : Qt4.Q_Real)
   is
   begin
      translate_0_wrapper
       (Self.QObject_View,
        Dx,
        Dy);
   end Translate;

   --------------------------
   -- Viewport_Update_Mode --
   --------------------------

   function Viewport_Update_Mode
    (Self : not null access constant Q_Graphics_View'Class)
       return Qt4.Graphics_Views.Graphics_View_Viewport_Update_Mode
   is
   begin
      return
        viewportUpdateMode_0_wrapper
         (Self.QObject_View);
   end Viewport_Update_Mode;

   -----------------------
   -- Update_Scene_Rect --
   -----------------------

   procedure Update_Scene_Rect
    (Self : not null access Q_Graphics_View'Class;
     Rect : Qt4.Rect_Fs.Q_Rect_F)
   is
   begin
      updateSceneRect_0_wrapper
       (Self.QObject_View,
        Qt4.Rect_Fs.Internals.QRectF_View (Rect));
   end Update_Scene_Rect;

end Qt4.Graphics_Views;
